# You should be running "mmxpg" from the Home folder.  Refer to the readme.txt file.
# Be sure to add two backslashes at the end of each path.
workingpath = "C:\\projects\\mmxpg\\"
assetpath = workingpath + "assets\\"
geometry = "+0+0"  # 100 pixels right of the top-left corner

# Cosmetic settings
fontframeheader = ("Times New Roman", 12)
fontbuttons = ("Calibri", 12)
fontlabels = ("Lucida Console", 16)
listbuttonwidth = 34
canvasheight = 672  # Full height is 672 (higher values are capped at 672).  Adjust it for lower-resolution displays.
canvaswidth = 1536  # Full width is 1536.  Higher values are capped as before.
windowfgcolor = "gold"
windowbgcolor = "grey1"
canvasbgcolor = "slate gray"
framebgcolor = "forest green"
buttonfgcolor = "alice blue"
buttonbgcolor = "light slate gray"

# This is a list of paths to each image to fetch.  You shouldn't modify this.
assets = {
	"pane-a" : assetpath + "Pane A.png",
	"dr-light" : assetpath + "Dr Light.png",
	"dr-light-no" : assetpath + "Dr Light Taken.png",
	"sub-tank" : assetpath + "Sub Tank.png",
	"sub-tank-no" : assetpath + "Sub Tank Taken.png",
	"heart-tank" : assetpath + "Heart Tank.png",
	"heart-tank-no" : assetpath + "Heart Tank Taken.png",
	"weapon-b-cutter" : assetpath + "Weapon B-Cutter.png",
	"weapon-b-cutter-no" : assetpath + "Weapon B-Cutter Taken.png",
	"weapon-c-sting" : assetpath + "Weapon C-Sting.png",
	"weapon-c-sting-no" : assetpath + "Weapon C-Sting Taken.png",
	"weapon-e-spark" : assetpath + "Weapon E-Spark.png",
	"weapon-e-spark-no" : assetpath + "Weapon E-Spark Taken.png",
	"weapon-fire-w" : assetpath + "Weapon Fire-W.png",
	"weapon-fire-w-no" : assetpath + "Weapon Fire-W Taken.png",
	"weapon-homing-t" : assetpath + "Weapon Homing-T.png",
	"weapon-homing-t-no" : assetpath + "Weapon Homing-T Taken.png",
	"weapon-r-shield" : assetpath + "Weapon R-Shield.png",
	"weapon-r-shield-no" : assetpath + "Weapon R-Shield Taken.png",
	"weapon-s-ice" : assetpath + "Weapon S-Ice.png",
	"weapon-s-ice-no" : assetpath + "Weapon S-Ice Taken.png",
	"weapon-storm-t" : assetpath + "Weapon Storm-T.png",
	"weapon-storm-t-no" : assetpath + "Weapon Storm-T Taken.png",
	"weapon-x-buster" : assetpath + "Weapon X-Buster.png",
	"pane-b" : assetpath + "Pane B.png",
	"light-off" : assetpath + "Light Off.png",
	"light-on-red" : assetpath + "Light On Red.png",
	"light-on-orange" : assetpath + "Light On Orange.png",
	"light-on-lemon" : assetpath + "Light On Lemon.png",
	"light-on-lime" : assetpath + "Light On Lime.png",
	"light-on-indigo" : assetpath + "Light On Indigo.png",
	"light-on-purple" : assetpath + "Light On Purple.png",
	"number-1" : assetpath + "Number 1.png",
	"number-2" : assetpath + "Number 2.png",
	"number-3" : assetpath + "Number 3.png",
	"number-4" : assetpath + "Number 4.png",
	"number-5" : assetpath + "Number 5.png",
	"number-6" : assetpath + "Number 6.png",
	"number-7" : assetpath + "Number 7.png",
	"number-8" : assetpath + "Number 8.png"
}

# EOF
