import tkinter as tk
from tkinter import messagebox
import config

class Application (tk.Frame):
	def __init__(self, master = None):
		tk.Frame.__init__(self, master)
		self.grid (sticky = tk.N + tk.S + tk.E + tk.W)
		self.createWidgets()

	def createWidgets (self):
		top = self.winfo_toplevel()
		top.rowconfigure (0, weight = 1)
		top.columnconfigure (0, weight = 1)
		self.rowconfigure (0, weight = 1)
		self.columnconfigure (0, weight = 1)

		# "Explicit" variable declarations
		self.varBitA = tk.BooleanVar()
		self.varBitB = tk.BooleanVar()
		self.varBitC = tk.BooleanVar()
		self.varBitD = tk.BooleanVar()
		self.varBitE = tk.BooleanVar()
		self.varBitF = tk.BooleanVar()
		self.varBitG = tk.BooleanVar()
		self.varBitH = tk.BooleanVar()
		self.varBitI = tk.BooleanVar()
		self.varBitJ = tk.BooleanVar()
		self.varBitK = tk.BooleanVar()
		self.varBitL = tk.BooleanVar()
		self.varBitM = tk.BooleanVar()
		self.varBitN = tk.BooleanVar()
		self.varBitO = tk.BooleanVar()
		self.varBitP = tk.BooleanVar()
		self.varBitQ = tk.BooleanVar()
		self.varBitR = tk.BooleanVar()
		self.varBitS = tk.BooleanVar()
		self.varBitT = tk.BooleanVar()
		self.varBitU = tk.BooleanVar()
		self.varBitV = tk.BooleanVar()
		self.varBitW = tk.BooleanVar()
		self.varBitX = tk.BooleanVar()
		self.varBitY = tk.BooleanVar()
		self.varBitZ = tk.BooleanVar()
		self.varBit0 = tk.BooleanVar()
		self.varBit1 = tk.BooleanVar()
		self.varBit2 = tk.BooleanVar()
		self.varBit3 = tk.BooleanVar()
		self.varBit4 = tk.BooleanVar()
		self.varBit5 = tk.BooleanVar()
		self.varBit6 = tk.BooleanVar()
		self.varBit7 = tk.BooleanVar()
		self.varBit8 = tk.BooleanVar()
		self.varBit9 = tk.BooleanVar()
		self.varBitAPrime = tk.BooleanVar()
		self.varBitBPrime = tk.BooleanVar()
		self.varBitCPrime = tk.BooleanVar()
		self.varBitDPrime = tk.BooleanVar()
		self.varBitEPrime = tk.BooleanVar()
		self.varBitFPrime = tk.BooleanVar()
		self.varBitGPrime = tk.BooleanVar()
		self.varBitHPrime = tk.BooleanVar()
		self.varBitIPrime = tk.BooleanVar()
		self.varBitJPrime = tk.BooleanVar()
		self.varBitKPrime = tk.BooleanVar()
		self.varBitLPrime = tk.BooleanVar()
		self.varBitMPrime = tk.BooleanVar()
		self.varBitNPrime = tk.BooleanVar()
		self.varBitOPrime = tk.BooleanVar()
		self.varBitPPrime = tk.BooleanVar()
		self.varBitQPrime = tk.BooleanVar()
		self.varBitRPrime = tk.BooleanVar()
		self.varBitSPrime = tk.BooleanVar()
		self.varBitTPrime = tk.BooleanVar()
		self.varBitUPrime = tk.BooleanVar()
		self.varBitVPrime = tk.BooleanVar()
		self.varBitWPrime = tk.BooleanVar()
		self.varBitXPrime = tk.BooleanVar()
		self.varBitZ.set (True)
		self.varBit6.set (True)
		self.varBitAPrime.set (True)
		self.varBitEPrime.set (True)
		self.varBitIPrime.set (True)
		self.varBitMPrime.set (True)
		self.varBitQPrime.set (True)
		self.varBitUPrime.set (True)

		# Image objects
		self.imgPaneA = tk.PhotoImage (file = config.assets ["pane-a"])
		self.imgDrLightStormEagle = tk.PhotoImage (file = config.assets ["dr-light"])
		self.imgDrLightFlameMammoth = tk.PhotoImage (file = config.assets ["dr-light"])
		self.imgDrLightStingChameleon = tk.PhotoImage (file = config.assets ["dr-light"])
		self.imgDrLightChillPenguin = tk.PhotoImage (file = config.assets ["dr-light"])
		self.imgSubTankStormEagle = tk.PhotoImage (file = config.assets ["sub-tank"])
		self.imgSubTankArmoredArmadillo = tk.PhotoImage (file = config.assets ["sub-tank"])
		self.imgSubTankSparkMandrill = tk.PhotoImage (file = config.assets ["sub-tank"])
		self.imgSubTankFlameMammoth = tk.PhotoImage (file = config.assets ["sub-tank"])
		self.imgHeartTankChillPenguin = tk.PhotoImage (file = config.assets ["heart-tank"])
		self.imgHeartTankArmoredArmadillo = tk.PhotoImage (file = config.assets ["heart-tank"])
		self.imgHeartTankStormEagle = tk.PhotoImage (file = config.assets ["heart-tank"])
		self.imgHeartTankStingChameleon = tk.PhotoImage (file = config.assets ["heart-tank"])
		self.imgHeartTankFlameMammoth = tk.PhotoImage (file = config.assets ["heart-tank"])
		self.imgHeartTankBoomerKuwanger = tk.PhotoImage (file = config.assets ["heart-tank"])
		self.imgHeartTankSparkMandrill = tk.PhotoImage (file = config.assets ["heart-tank"])
		self.imgHeartTankLaunchOctopus = tk.PhotoImage (file = config.assets ["heart-tank"])
		self.imgWeaponHomingTorpedo = tk.PhotoImage (file = config.assets ["weapon-homing-t"])
		self.imgWeaponChameleonSting = tk.PhotoImage (file = config.assets ["weapon-c-sting"])
		self.imgWeaponRollingShield = tk.PhotoImage (file = config.assets ["weapon-r-shield"])
		self.imgWeaponFireWave = tk.PhotoImage (file = config.assets ["weapon-fire-w"])
		self.imgWeaponStormTornado = tk.PhotoImage (file = config.assets ["weapon-storm-t"])
		self.imgWeaponElectricSpark = tk.PhotoImage (file = config.assets ["weapon-e-spark"])
		self.imgWeaponBoomerangCutter = tk.PhotoImage (file = config.assets ["weapon-b-cutter"])
		self.imgWeaponShotgunIce = tk.PhotoImage (file = config.assets ["weapon-s-ice"])
		self.imgDrLightArmoredArmadillo = tk.PhotoImage (file = config.assets ["dr-light"])

		self.imgPaneB = tk.PhotoImage (file = config.assets ["pane-b"])
		self.imgBitA = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitB = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitC = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitD = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitE = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitF = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitG = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitH = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitI = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitJ = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitK = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitL = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitM = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitN = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitO = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitP = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitQ = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitR = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitS = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitT = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitU = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitV = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitW = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitX = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitY = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitZ = tk.PhotoImage (file = config.assets ["light-on-lemon"])
		self.imgBit0 = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit1 = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit2 = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit3 = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit4 = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit5 = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit6 = tk.PhotoImage (file = config.assets ["light-on-lime"])
		self.imgBit7 = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit8 = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit9 = tk.PhotoImage (file = config.assets ["light-off"])

		self.imgBitAPrime = tk.PhotoImage (file = config.assets ["light-on-indigo"])
		self.imgBitBPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitCPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitDPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitEPrime = tk.PhotoImage (file = config.assets ["light-on-orange"])
		self.imgBitFPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitGPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitHPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitIPrime = tk.PhotoImage (file = config.assets ["light-on-red"])
		self.imgBitJPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitKPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitLPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitMPrime = tk.PhotoImage (file = config.assets ["light-on-red"])
		self.imgBitNPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitOPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitPPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitQPrime = tk.PhotoImage (file = config.assets ["light-on-purple"])
		self.imgBitRPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitSPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitTPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitUPrime = tk.PhotoImage (file = config.assets ["light-on-purple"])
		self.imgBitVPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitWPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitXPrime = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBitZDup = tk.PhotoImage (file = config.assets ["light-on-lemon"])
		self.imgBit2Dup = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit1Dup = tk.PhotoImage (file = config.assets ["light-off"])
		self.imgBit0Dup = tk.PhotoImage (file = config.assets ["light-off"])

		self.imgDigit00 = tk.PhotoImage (file = config.assets ["number-1"])
		self.imgDigit01 = tk.PhotoImage (file = config.assets ["number-7"])
		self.imgDigit02 = tk.PhotoImage (file = config.assets ["number-6"])
		self.imgDigit03 = tk.PhotoImage (file = config.assets ["number-8"])
		self.imgDigit10 = tk.PhotoImage (file = config.assets ["number-5"])
		self.imgDigit11 = tk.PhotoImage (file = config.assets ["number-8"])
		self.imgDigit12 = tk.PhotoImage (file = config.assets ["number-5"])
		self.imgDigit13 = tk.PhotoImage (file = config.assets ["number-8"])
		self.imgDigit20 = tk.PhotoImage (file = config.assets ["number-3"])
		self.imgDigit21 = tk.PhotoImage (file = config.assets ["number-8"])
		self.imgDigit22 = tk.PhotoImage (file = config.assets ["number-8"])
		self.imgDigit23 = tk.PhotoImage (file = config.assets ["number-4"])

		# Scrollbars
		self.xScroll = tk.Scrollbar (self, width = 24, orient = tk.HORIZONTAL)
		self.xScroll.grid (row = 1, column = 2, sticky = tk.W + tk.E)
		self.yScrollList = tk.Scrollbar (self, width = 24, orient = tk.VERTICAL)
		self.yScrollList.grid (row = 0, column = 1, rowspan = 2, sticky = tk.N + tk.S)
		self.yScrollScreens = tk.Scrollbar (self, width = 24, orient = tk.VERTICAL)
		self.yScrollScreens.grid (row = 0, column = 3, sticky = tk.N + tk.S)

		# Canvases
		self.canvasList = tk.Canvas (self, bg = config.canvasbgcolor, height = min (config.canvasheight, 672), width = 314, scrollregion = (0, 0, 313, 979), yscrollcommand = self.yScrollList.set)
		self.canvasList.grid (row = 0, column = 0, rowspan = 2)
		self.yScrollList ["command"] = self.canvasList.yview
		self.canvasScreens = tk.Canvas (self, bg = config.canvasbgcolor, height = min (config.canvasheight, 672), width = min (config.canvaswidth, 1536), scrollregion = (0, 0, 1535, 671), xscrollcommand = self.xScroll.set, yscrollcommand = self.yScrollScreens.set)
		self.canvasScreens.grid (row = 0, column = 2)
		self.xScroll ["command"] = self.canvasScreens.xview  # Needed to make the scrollbars moveable
		self.yScrollScreens ["command"] = self.canvasScreens.yview
		self.canvasScreens.create_image (0, 0, anchor = tk.N + tk.W, image = self.imgPaneA)  # We're posting these onto the canvas now because other widgets are going to be overlayed above them.
		self.canvasScreens.create_image (768, 0, anchor = tk.N + tk.W, image = self.imgPaneB)

		# Frames
		self.frameDataBits = tk.LabelFrame (self, font = config.fontframeheader, labelanchor = "n", text = "Data Bits", bg = config.framebgcolor)  # Setting labelanchor to N centers the label text across the top line of the frame.
		self.canvasList.create_window (0, 0, anchor = tk.N + tk.W, window = self.frameDataBits)
		self.frameSeedBits = tk.LabelFrame (self, font = config.fontframeheader, labelanchor = "n", text = "Seed Bits", bg = config.framebgcolor)
		self.canvasScreens.create_window (600, 550, window = self.frameSeedBits)

		# Command Buttons
		self.btnHelp = tk.Button (self, font = config.fontbuttons, text = "Help", bg = config.buttonbgcolor, fg = config.buttonfgcolor, state = tk.NORMAL, command = self.dohelp)
		self.canvasScreens.create_window (169, 118, window = self.btnHelp)
		self.btnAbout = tk.Button (self, font = config.fontbuttons, text = "About", bg = config.buttonbgcolor, fg = config.buttonfgcolor, state = tk.NORMAL, command = self.doabout)
		self.canvasScreens.create_window (169, 550, window = self.btnAbout)
		self.btnQuit = tk.Button (self, font = config.fontbuttons, text = "Quit", bg = config.buttonbgcolor, fg = config.buttonfgcolor, state = tk.NORMAL, command = self.quit)
		self.canvasScreens.create_window (601, 118, window = self.btnQuit)
		self.btnBitZ = tk.Button (self.frameSeedBits, font = config.fontbuttons, text = "Z (completed\nfirst stage)", bg = config.buttonbgcolor, fg = config.buttonfgcolor, state = tk.NORMAL, command = self.dotoggleBitZ)
		self.btnBitZ.grid (row = 0, column = 0, columnspan = 3)
		self.btnBit2 = tk.Button (self.frameSeedBits, font = config.fontbuttons, text = "2", bg = config.buttonbgcolor, fg = config.buttonfgcolor, state = tk.NORMAL, command = self.dotoggleBit2)
		self.btnBit2.grid (row = 1, column = 0)
		self.btnBit1 = tk.Button (self.frameSeedBits, font = config.fontbuttons, text = "1", bg = config.buttonbgcolor, fg = config.buttonfgcolor, state = tk.NORMAL, command = self.dotoggleBit1)
		self.btnBit1.grid (row = 1, column = 1)
		self.btnBit0 = tk.Button (self.frameSeedBits, font = config.fontbuttons, text = "0", bg = config.buttonbgcolor, fg = config.buttonfgcolor, state = tk.NORMAL, command = self.dotoggleBit0)
		self.btnBit0.grid (row = 1, column = 2)

		# Checkbuttons and Buttons for the Data Bits frame
		self.chkBitA = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitA, command = self.dotoggleBitA)
		self.chkBitA.grid (row = 0, column = 0)
		self.btnBitA = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "A. Have Dr. Light upgrade: Helmet", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitA)
		self.btnBitA.grid (row = 0, column = 1)
		self.chkBitB = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitB, command = self.dotoggleBitB)
		self.chkBitB.grid (row = 1, column = 0)
		self.btnBitB = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "B. Have Dr. Light upgrade: Weapons", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitB)
		self.btnBitB.grid (row = 1, column = 1)
		self.chkBitC = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitC, command = self.dotoggleBitC)
		self.chkBitC.grid (row = 2, column = 0)
		self.btnBitC = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "C. Have Dr. Light upgrade: Armor", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitC)
		self.btnBitC.grid (row = 2, column = 1)
		self.chkBitD = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitD, command = self.dotoggleBitD)
		self.chkBitD.grid (row = 3, column = 0)
		self.btnBitD = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "D. Have Dr. Light upgrade: Boots", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitD)
		self.btnBitD.grid (row = 3, column = 1)
		self.chkBitE = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitE, command = self.dotoggleBitE)
		self.chkBitE.grid (row = 4, column = 0)
		self.btnBitE = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "E. Have Sub Tank: Storm Eagle", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitE)
		self.btnBitE.grid (row = 4, column = 1)
		self.chkBitF = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitF, command = self.dotoggleBitF)
		self.chkBitF.grid (row = 5, column = 0)
		self.btnBitF = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "F. Have Sub Tank: Armored Armadillo", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitF)
		self.btnBitF.grid (row = 5, column = 1)
		self.chkBitG = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitG, command = self.dotoggleBitG)
		self.chkBitG.grid (row = 6, column = 0)
		self.btnBitG = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "G. Have Sub Tank: Spark Mandrill", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitG)
		self.btnBitG.grid (row = 6, column = 1)
		self.chkBitH = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitH, command = self.dotoggleBitH)
		self.chkBitH.grid (row = 7, column = 0)
		self.btnBitH = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "H. Have Sub Tank: Flame Mammoth", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitH)
		self.btnBitH.grid (row = 7, column = 1)
		self.chkBitI = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitI, command = self.dotoggleBitI)
		self.chkBitI.grid (row = 8, column = 0)
		self.btnBitI = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "I. Have Heart Tank: Chill Penguin", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitI)
		self.btnBitI.grid (row = 8, column = 1)
		self.chkBitJ = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitJ, command = self.dotoggleBitJ)
		self.chkBitJ.grid (row = 9, column = 0)
		self.btnBitJ = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "J. Have Heart Tank: Armored Armadillo", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitJ)
		self.btnBitJ.grid (row = 9, column = 1)
		self.chkBitK = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitK, command = self.dotoggleBitK)
		self.chkBitK.grid (row = 10, column = 0)
		self.btnBitK = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "K. Have Heart Tank: Storm Eagle", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitK)
		self.btnBitK.grid (row = 10, column = 1)
		self.chkBitL = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitL, command = self.dotoggleBitL)
		self.chkBitL.grid (row = 11, column = 0)
		self.btnBitL = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "L. Have Heart Tank: Sting Chameleon", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitL)
		self.btnBitL.grid (row = 11, column = 1)
		self.chkBitM = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitM, command = self.dotoggleBitM)
		self.chkBitM.grid (row = 12, column = 0)
		self.btnBitM = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "M. Have Heart Tank: Flame Mammoth", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitM)
		self.btnBitM.grid (row = 12, column = 1)
		self.chkBitN = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitN, command = self.dotoggleBitN)
		self.chkBitN.grid (row = 13, column = 0)
		self.btnBitN = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "N. Have Heart Tank: Boomer Kuwanger", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitN)
		self.btnBitN.grid (row = 13, column = 1)
		self.chkBitO = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitO, command = self.dotoggleBitO)
		self.chkBitO.grid (row = 14, column = 0)
		self.btnBitO = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "O. Have Heart Tank: Spark Mandrill", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitO)
		self.btnBitO.grid (row = 14, column = 1)
		self.chkBitP = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitP, command = self.dotoggleBitP)
		self.chkBitP.grid (row = 15, column = 0)
		self.btnBitP = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "P. Have Heart Tank: Launch Octopus", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitP)
		self.btnBitP.grid (row = 15, column = 1)
		self.chkBitQ = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitQ, command = self.dotoggleBitQ)
		self.chkBitQ.grid (row = 16, column = 0)
		self.btnBitQ = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "Q. Have Weapon: Homing Torpedo", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitQ)
		self.btnBitQ.grid (row = 16, column = 1)
		self.chkBitR = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitR, command = self.dotoggleBitR)
		self.chkBitR.grid (row = 17, column = 0)
		self.btnBitR = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "R. Have Weapon: Chameleon Sting", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitR)
		self.btnBitR.grid (row = 17, column = 1)
		self.chkBitS = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitS, command = self.dotoggleBitS)
		self.chkBitS.grid (row = 18, column = 0)
		self.btnBitS = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "S. Have Weapon: Rolling Shield", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitS)
		self.btnBitS.grid (row = 18, column = 1)
		self.chkBitT = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitT, command = self.dotoggleBitT)
		self.chkBitT.grid (row = 19, column = 0)
		self.btnBitT = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "T. Have Weapon: Fire Wave", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitT)
		self.btnBitT.grid (row = 19, column = 1)
		self.chkBitU = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitU, command = self.dotoggleBitU)
		self.chkBitU.grid (row = 20, column = 0)
		self.btnBitU = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "U. Have Weapon: Storm Tornado", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitU)
		self.btnBitU.grid (row = 20, column = 1)
		self.chkBitV = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitV, command = self.dotoggleBitV)
		self.chkBitV.grid (row = 21, column = 0)
		self.btnBitV = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "V. Have Weapon: Electric Spark", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitV)
		self.btnBitV.grid (row = 21, column = 1)
		self.chkBitW = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitW, command = self.dotoggleBitW)
		self.chkBitW.grid (row = 22, column = 0)
		self.btnBitW = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "W. Have Weapon: Boomerang Cutter", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitW)
		self.btnBitW.grid (row = 22, column = 1)
		self.chkBitX = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitX, command = self.dotoggleBitX)
		self.chkBitX.grid (row = 23, column = 0)
		self.btnBitX = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "X. Have Weapon: Shotgun Ice", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitX)
		self.btnBitX.grid (row = 23, column = 1)
		self.chkBitY = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitY, command = self.dotoggleBitY)
		self.chkBitY.grid (row = 24, column = 0)
		self.btnBitY = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "Y. Have Dr. Light upgrade: Hadouken*", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitY)
		self.btnBitY.grid (row = 24, column = 1)
		self.chkBitZ = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBitZ, command = self.dotoggleBitZ)
		self.chkBitZ.grid (row = 25, column = 0)
		self.btnBitZ = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "Z. Completed first stage (also a Seed Bit)", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBitZ)
		self.btnBitZ.grid (row = 25, column = 1)
		self.chkBit2 = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBit2, command = self.dotoggleBit2)
		self.chkBit2.grid (row = 26, column = 0)
		self.btnBit2 = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "2. Random Seed Bit", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBit2)
		self.btnBit2.grid (row = 26, column = 1)
		self.chkBit1 = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBit1, command = self.dotoggleBit1)
		self.chkBit1.grid (row = 27, column = 0)
		self.btnBit1 = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "1. Random Seed Bit", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBit1)
		self.btnBit1.grid (row = 27, column = 1)
		self.chkBit0 = tk.Checkbutton (self.frameDataBits, font = config.fontbuttons, variable = self.varBit0, command = self.dotoggleBit0)
		self.chkBit0.grid (row = 28, column = 0)
		self.btnBit0 = tk.Button (self.frameDataBits, width = config.listbuttonwidth, font = config.fontbuttons, text = "0. Random Seed Bit", bg = config.buttonbgcolor, fg = config.buttonfgcolor, anchor = tk.W, state = tk.NORMAL, command = self.dotoggleBit0)
		self.btnBit0.grid (row = 28, column = 1)

		# Icons for the Stage Select screen
		self.btnDrLightStormEagle = tk.Button (self, image = self.imgDrLightStormEagle, height = 32, width = 32, command = self.dotoggleBitA)
		self.canvasScreens.create_window (104, 333, anchor = tk.N + tk.E, window = self.btnDrLightStormEagle)
		self.btnDrLightFlameMammoth = tk.Button (self, image = self.imgDrLightFlameMammoth, height = 32, width = 32, command = self.dotoggleBitB)
		self.canvasScreens.create_window (663, 218, anchor = tk.S + tk.W, window = self.btnDrLightFlameMammoth)
		self.btnDrLightStingChameleon = tk.Button (self, image = self.imgDrLightStingChameleon, height = 32, width = 32, command = self.dotoggleBitC)
		self.canvasScreens.create_window (399, 612, anchor = tk.N + tk.W, window = self.btnDrLightStingChameleon)
		self.btnDrLightChillPenguin = tk.Button (self, image = self.imgDrLightChillPenguin, height = 32, width = 32, command = self.dotoggleBitD)
		self.canvasScreens.create_window (399, 53, anchor = tk.S + tk.W, window = self.btnDrLightChillPenguin)
		self.btnSubTankStormEagle = tk.Button (self, image = self.imgSubTankStormEagle, height = 32, width = 32, command = self.dotoggleBitE)
		self.canvasScreens.create_window (104, 371, anchor = tk.N + tk.E, window = self.btnSubTankStormEagle)
		self.btnSubTankArmoredArmadillo = tk.Button (self, image = self.imgSubTankArmoredArmadillo, height = 32, width = 32, command = self.dotoggleBitF)
		self.canvasScreens.create_window (104, 256, anchor = tk.S + tk.E, window = self.btnSubTankArmoredArmadillo)
		self.btnSubTankSparkMandrill = tk.Button (self, image = self.imgSubTankSparkMandrill, height = 32, width = 32, command = self.dotoggleBitG)
		self.canvasScreens.create_window (292, 612, anchor = tk.N + tk.E, window = self.btnSubTankSparkMandrill)
		self.btnSubTankFlameMammoth = tk.Button (self, image = self.imgSubTankFlameMammoth, height = 32, width = 32, command = self.dotoggleBitH)
		self.canvasScreens.create_window (663, 256, anchor = tk.S + tk.W, window = self.btnSubTankFlameMammoth)
		self.btnHeartTankChillPenguin = tk.Button (self, image = self.imgHeartTankChillPenguin, height = 32, width = 32, command = self.dotoggleBitI)
		self.canvasScreens.create_window (437, 53, anchor = tk.S + tk.W, window = self.btnHeartTankChillPenguin)
		self.btnHeartTankArmoredArmadillo = tk.Button (self, image = self.imgHeartTankArmoredArmadillo, height = 32, width = 32, command = self.dotoggleBitJ)
		self.canvasScreens.create_window (104, 294, anchor = tk.S + tk.E, window = self.btnHeartTankArmoredArmadillo)
		self.btnHeartTankStormEagle = tk.Button (self, image = self.imgHeartTankStormEagle, height = 32, width = 32, command = self.dotoggleBitK)
		self.canvasScreens.create_window (104, 409, anchor = tk.N + tk.E, window = self.btnHeartTankStormEagle)
		self.btnHeartTankStingChameleon = tk.Button (self, image = self.imgHeartTankStingChameleon, height = 32, width = 32, command = self.dotoggleBitL)
		self.canvasScreens.create_window (437, 612, anchor = tk.N + tk.W, window = self.btnHeartTankStingChameleon)
		self.btnHeartTankFlameMammoth = tk.Button (self, image = self.imgHeartTankFlameMammoth, height = 32, width = 32, command = self.dotoggleBitM)
		self.canvasScreens.create_window (663, 294, anchor = tk.S + tk.W, window = self.btnHeartTankFlameMammoth)
		self.btnHeartTankBoomerKuwanger = tk.Button (self, image = self.imgHeartTankBoomerKuwanger, height = 32, width = 32, command = self.dotoggleBitN)
		self.canvasScreens.create_window (663, 368, anchor = tk.N + tk.W, window = self.btnHeartTankBoomerKuwanger)
		self.btnHeartTankSparkMandrill = tk.Button (self, image = self.imgHeartTankSparkMandrill, height = 32, width = 32, command = self.dotoggleBitO)
		self.canvasScreens.create_window (330, 612, anchor = tk.N + tk.E, window = self.btnHeartTankSparkMandrill)
		self.btnHeartTankLaunchOctopus = tk.Button (self, image = self.imgHeartTankLaunchOctopus, height = 32, width = 32, command = self.dotoggleBitP)
		self.canvasScreens.create_window (311, 53, anchor = tk.S + tk.E, window = self.btnHeartTankLaunchOctopus)
		self.btnWeaponHomingTorpedo = tk.Button (self, image = self.imgWeaponHomingTorpedo, height = 32, width = 32, command = self.dotoggleBitQ)
		self.canvasScreens.create_window (349, 53, anchor = tk.S + tk.E, window = self.btnWeaponHomingTorpedo)
		self.btnWeaponChameleonSting = tk.Button (self, image = self.imgWeaponChameleonSting, height = 32, width = 32, command = self.dotoggleBitR)
		self.canvasScreens.create_window (475, 612, anchor = tk.N + tk.W, window = self.btnWeaponChameleonSting)
		self.btnWeaponRollingShield = tk.Button (self, image = self.imgWeaponRollingShield, height = 32, width = 32, command = self.dotoggleBitS)
		self.canvasScreens.create_window (104, 332, anchor = tk.S + tk.E, window = self.btnWeaponRollingShield)
		self.btnWeaponFireWave = tk.Button (self, image = self.imgWeaponFireWave, height = 32, width = 32, command = self.dotoggleBitT)
		self.canvasScreens.create_window (663, 332, anchor = tk.S + tk.W, window = self.btnWeaponFireWave)
		self.btnWeaponStormTornado = tk.Button (self, image = self.imgWeaponStormTornado, height = 32, width = 32, command = self.dotoggleBitU)
		self.canvasScreens.create_window (104, 447, anchor = tk.N + tk.E, window = self.btnWeaponStormTornado)
		self.btnWeaponElectricSpark = tk.Button (self, image = self.imgWeaponElectricSpark, height = 32, width = 32, command = self.dotoggleBitV)
		self.canvasScreens.create_window (368, 612, anchor = tk.N + tk.E, window = self.btnWeaponElectricSpark)
		self.btnWeaponBoomerangCutter = tk.Button (self, image = self.imgWeaponBoomerangCutter, height = 32, width = 32, command = self.dotoggleBitW)
		self.canvasScreens.create_window (663, 406, anchor = tk.N + tk.W, window = self.btnWeaponBoomerangCutter)
		self.btnWeaponShotgunIce = tk.Button (self, image = self.imgWeaponShotgunIce, height = 32, width = 32, command = self.dotoggleBitX)
		self.canvasScreens.create_window (475, 53, anchor = tk.S + tk.W, window = self.btnWeaponShotgunIce)
		self.btnDrLightArmoredArmadillo = tk.Button (self, image = self.imgDrLightArmoredArmadillo, height = 32, width = 32, command = self.dotoggleBitY)
		self.canvasScreens.create_window (104, 218, anchor = tk.S + tk.E, window = self.btnDrLightArmoredArmadillo)

		# Lights for the Password screen
		self.lblBitA = tk.Label (self, image = self.imgBitA)
		self.canvasScreens.create_window (853, 58, anchor = tk.N + tk.W, window = self.lblBitA)
		self.lblBitB = tk.Label (self, image = self.imgBitB)
		self.canvasScreens.create_window (887, 58, anchor = tk.N + tk.W, window = self.lblBitB)
		self.lblBitC = tk.Label (self, image = self.imgBitC)
		self.canvasScreens.create_window (921, 58, anchor = tk.N + tk.W, window = self.lblBitC)
		self.lblBitD = tk.Label (self, image = self.imgBitD)
		self.canvasScreens.create_window (955, 58, anchor = tk.N + tk.W, window = self.lblBitD)
		self.lblBitE = tk.Label (self, image = self.imgBitE)
		self.canvasScreens.create_window (853, 118, anchor = tk.N + tk.W, window = self.lblBitE)
		self.lblBitF = tk.Label (self, image = self.imgBitF)
		self.canvasScreens.create_window (887, 118, anchor = tk.N + tk.W, window = self.lblBitF)
		self.lblBitG = tk.Label (self, image = self.imgBitG)
		self.canvasScreens.create_window (921, 118, anchor = tk.N + tk.W, window = self.lblBitG)
		self.lblBitH = tk.Label (self, image = self.imgBitH)
		self.canvasScreens.create_window (955, 118, anchor = tk.N + tk.W, window = self.lblBitH)
		self.lblBitI = tk.Label (self, image = self.imgBitI)
		self.canvasScreens.create_window (853, 178, anchor = tk.N + tk.W, window = self.lblBitI)
		self.lblBitJ = tk.Label (self, image = self.imgBitJ)
		self.canvasScreens.create_window (887, 178, anchor = tk.N + tk.W, window = self.lblBitJ)
		self.lblBitK = tk.Label (self, image = self.imgBitK)
		self.canvasScreens.create_window (921, 178, anchor = tk.N + tk.W, window = self.lblBitK)
		self.lblBitL = tk.Label (self, image = self.imgBitL)
		self.canvasScreens.create_window (955, 178, anchor = tk.N + tk.W, window = self.lblBitL)
		self.lblBitM = tk.Label (self, image = self.imgBitM)
		self.canvasScreens.create_window (853, 238, anchor = tk.N + tk.W, window = self.lblBitM)
		self.lblBitN = tk.Label (self, image = self.imgBitN)
		self.canvasScreens.create_window (887, 238, anchor = tk.N + tk.W, window = self.lblBitN)
		self.lblBitO = tk.Label (self, image = self.imgBitO)
		self.canvasScreens.create_window (921, 238, anchor = tk.N + tk.W, window = self.lblBitO)
		self.lblBitP = tk.Label (self, image = self.imgBitP)
		self.canvasScreens.create_window (955, 238, anchor = tk.N + tk.W, window = self.lblBitP)
		self.lblBitQ = tk.Label (self, image = self.imgBitQ)
		self.canvasScreens.create_window (853, 298, anchor = tk.N + tk.W, window = self.lblBitQ)
		self.lblBitR = tk.Label (self, image = self.imgBitR)
		self.canvasScreens.create_window (887, 298, anchor = tk.N + tk.W, window = self.lblBitR)
		self.lblBitS = tk.Label (self, image = self.imgBitS)
		self.canvasScreens.create_window (921, 298, anchor = tk.N + tk.W, window = self.lblBitS)
		self.lblBitT = tk.Label (self, image = self.imgBitT)
		self.canvasScreens.create_window (955, 298, anchor = tk.N + tk.W, window = self.lblBitT)
		self.lblBitU = tk.Label (self, image = self.imgBitU)
		self.canvasScreens.create_window (853, 358, anchor = tk.N + tk.W, window = self.lblBitU)
		self.lblBitV = tk.Label (self, image = self.imgBitV)
		self.canvasScreens.create_window (887, 358, anchor = tk.N + tk.W, window = self.lblBitV)
		self.lblBitW = tk.Label (self, image = self.imgBitW)
		self.canvasScreens.create_window (921, 358, anchor = tk.N + tk.W, window = self.lblBitW)
		self.lblBitX = tk.Label (self, image = self.imgBitX)
		self.canvasScreens.create_window (955, 358, anchor = tk.N + tk.W, window = self.lblBitX)
		self.lblBitY = tk.Label (self, image = self.imgBitY)
		self.canvasScreens.create_window (853, 418, anchor = tk.N + tk.W, window = self.lblBitY)
		self.lblBit5 = tk.Label (self, image = self.imgBit5)
		self.canvasScreens.create_window (887, 418, anchor = tk.N + tk.W, window = self.lblBit5)
		self.lblBit4 = tk.Label (self, image = self.imgBit4)
		self.canvasScreens.create_window (921, 418, anchor = tk.N + tk.W, window = self.lblBit4)
		self.lblBit3 = tk.Label (self, image = self.imgBit3)
		self.canvasScreens.create_window (955, 418, anchor = tk.N + tk.W, window = self.lblBit3)
		self.lblBitZ = tk.Label (self, image = self.imgBitZ)
		self.canvasScreens.create_window (853, 478, anchor = tk.N + tk.W, window = self.lblBitZ)
		self.lblBit2 = tk.Label (self, image = self.imgBit2)
		self.canvasScreens.create_window (887, 478, anchor = tk.N + tk.W, window = self.lblBit2)
		self.lblBit1 = tk.Label (self, image = self.imgBit1)
		self.canvasScreens.create_window (921, 478, anchor = tk.N + tk.W, window = self.lblBit1)
		self.lblBit0 = tk.Label (self, image = self.imgBit0)
		self.canvasScreens.create_window (955, 478, anchor = tk.N + tk.W, window = self.lblBit0)
		self.lblBit6 = tk.Label (self, image = self.imgBit6)
		self.canvasScreens.create_window (853, 538, anchor = tk.N + tk.W, window = self.lblBit6)
		self.lblBit7 = tk.Label (self, image = self.imgBit7)
		self.canvasScreens.create_window (887, 538, anchor = tk.N + tk.W, window = self.lblBit7)
		self.lblBit8 = tk.Label (self, image = self.imgBit8)
		self.canvasScreens.create_window (921, 538, anchor = tk.N + tk.W, window = self.lblBit8)
		self.lblBit9 = tk.Label (self, image = self.imgBit9)
		self.canvasScreens.create_window (955, 538, anchor = tk.N + tk.W, window = self.lblBit9)

		self.lblBitAPrime = tk.Label (self, image = self.imgBitAPrime)
		self.canvasScreens.create_window (1029, 58, anchor = tk.N + tk.W, window = self.lblBitAPrime)
		self.lblBitBPrime = tk.Label (self, image = self.imgBitBPrime)
		self.canvasScreens.create_window (1063, 58, anchor = tk.N + tk.W, window = self.lblBitBPrime)
		self.lblBitCPrime = tk.Label (self, image = self.imgBitCPrime)
		self.canvasScreens.create_window (1097, 58, anchor = tk.N + tk.W, window = self.lblBitCPrime)
		self.lblBitDPrime = tk.Label (self, image = self.imgBitDPrime)
		self.canvasScreens.create_window (1131, 58, anchor = tk.N + tk.W, window = self.lblBitDPrime)
		self.lblBitEPrime = tk.Label (self, image = self.imgBitEPrime)
		self.canvasScreens.create_window (1029, 118, anchor = tk.N + tk.W, window = self.lblBitEPrime)
		self.lblBitFPrime = tk.Label (self, image = self.imgBitFPrime)
		self.canvasScreens.create_window (1063, 118, anchor = tk.N + tk.W, window = self.lblBitFPrime)
		self.lblBitGPrime = tk.Label (self, image = self.imgBitGPrime)
		self.canvasScreens.create_window (1097, 118, anchor = tk.N + tk.W, window = self.lblBitGPrime)
		self.lblBitHPrime = tk.Label (self, image = self.imgBitHPrime)
		self.canvasScreens.create_window (1131, 118, anchor = tk.N + tk.W, window = self.lblBitHPrime)
		self.lblBitIPrime = tk.Label (self, image = self.imgBitIPrime)
		self.canvasScreens.create_window (1029, 178, anchor = tk.N + tk.W, window = self.lblBitIPrime)
		self.lblBitJPrime = tk.Label (self, image = self.imgBitJPrime)
		self.canvasScreens.create_window (1063, 178, anchor = tk.N + tk.W, window = self.lblBitJPrime)
		self.lblBitKPrime = tk.Label (self, image = self.imgBitKPrime)
		self.canvasScreens.create_window (1097, 178, anchor = tk.N + tk.W, window = self.lblBitKPrime)
		self.lblBitLPrime = tk.Label (self, image = self.imgBitLPrime)
		self.canvasScreens.create_window (1131, 178, anchor = tk.N + tk.W, window = self.lblBitLPrime)
		self.lblBitMPrime = tk.Label (self, image = self.imgBitMPrime)
		self.canvasScreens.create_window (1029, 238, anchor = tk.N + tk.W, window = self.lblBitMPrime)
		self.lblBitNPrime = tk.Label (self, image = self.imgBitNPrime)
		self.canvasScreens.create_window (1063, 238, anchor = tk.N + tk.W, window = self.lblBitNPrime)
		self.lblBitOPrime = tk.Label (self, image = self.imgBitOPrime)
		self.canvasScreens.create_window (1097, 238, anchor = tk.N + tk.W, window = self.lblBitOPrime)
		self.lblBitPPrime = tk.Label (self, image = self.imgBitPPrime)
		self.canvasScreens.create_window (1131, 238, anchor = tk.N + tk.W, window = self.lblBitPPrime)
		self.lblBitQPrime = tk.Label (self, image = self.imgBitQPrime)
		self.canvasScreens.create_window (1029, 298, anchor = tk.N + tk.W, window = self.lblBitQPrime)
		self.lblBitRPrime = tk.Label (self, image = self.imgBitRPrime)
		self.canvasScreens.create_window (1063, 298, anchor = tk.N + tk.W, window = self.lblBitRPrime)
		self.lblBitSPrime = tk.Label (self, image = self.imgBitSPrime)
		self.canvasScreens.create_window (1097, 298, anchor = tk.N + tk.W, window = self.lblBitSPrime)
		self.lblBitTPrime = tk.Label (self, image = self.imgBitTPrime)
		self.canvasScreens.create_window (1131, 298, anchor = tk.N + tk.W, window = self.lblBitTPrime)
		self.lblBitUPrime = tk.Label (self, image = self.imgBitUPrime)
		self.canvasScreens.create_window (1029, 358, anchor = tk.N + tk.W, window = self.lblBitUPrime)
		self.lblBitVPrime = tk.Label (self, image = self.imgBitVPrime)
		self.canvasScreens.create_window (1063, 358, anchor = tk.N + tk.W, window = self.lblBitVPrime)
		self.lblBitWPrime = tk.Label (self, image = self.imgBitWPrime)
		self.canvasScreens.create_window (1097, 358, anchor = tk.N + tk.W, window = self.lblBitWPrime)
		self.lblBitXPrime = tk.Label (self, image = self.imgBitXPrime)
		self.canvasScreens.create_window (1131, 358, anchor = tk.N + tk.W, window = self.lblBitXPrime)
		self.lblBitZDup = tk.Label (self, image = self.imgBitZ)
		self.canvasScreens.create_window (1029, 478, anchor = tk.N + tk.W, window = self.lblBitZDup)
		self.lblBit2Dup = tk.Label (self, image = self.imgBit2)
		self.canvasScreens.create_window (1063, 478, anchor = tk.N + tk.W, window = self.lblBit2Dup)
		self.lblBit1Dup = tk.Label (self, image = self.imgBit1)
		self.canvasScreens.create_window (1097, 478, anchor = tk.N + tk.W, window = self.lblBit1Dup)
		self.lblBit0Dup = tk.Label (self, image = self.imgBit0)
		self.canvasScreens.create_window (1131, 478, anchor = tk.N + tk.W, window = self.lblBit0Dup)

		# Password digits
		self.lblDigit00 = tk.Label (self, image = self.imgDigit00)
		self.canvasScreens.create_window (1210, 110, anchor = tk.N + tk.W, window = self.lblDigit00)
		self.lblDigit01 = tk.Label (self, image = self.imgDigit01)
		self.canvasScreens.create_window (1270, 110, anchor = tk.N + tk.W, window = self.lblDigit01)
		self.lblDigit02 = tk.Label (self, image = self.imgDigit02)
		self.canvasScreens.create_window (1330, 110, anchor = tk.N + tk.W, window = self.lblDigit02)
		self.lblDigit03 = tk.Label (self, image = self.imgDigit03)
		self.canvasScreens.create_window (1390, 110, anchor = tk.N + tk.W, window = self.lblDigit03)
		self.lblDigit10 = tk.Label (self, image = self.imgDigit10)
		self.canvasScreens.create_window (1210, 160, anchor = tk.N + tk.W, window = self.lblDigit10)
		self.lblDigit11 = tk.Label (self, image = self.imgDigit11)
		self.canvasScreens.create_window (1270, 160, anchor = tk.N + tk.W, window = self.lblDigit11)
		self.lblDigit12 = tk.Label (self, image = self.imgDigit12)
		self.canvasScreens.create_window (1330, 160, anchor = tk.N + tk.W, window = self.lblDigit12)
		self.lblDigit13 = tk.Label (self, image = self.imgDigit13)
		self.canvasScreens.create_window (1390, 160, anchor = tk.N + tk.W, window = self.lblDigit13)
		self.lblDigit20 = tk.Label (self, image = self.imgDigit20)
		self.canvasScreens.create_window (1210, 210, anchor = tk.N + tk.W, window = self.lblDigit20)
		self.lblDigit21 = tk.Label (self, image = self.imgDigit21)
		self.canvasScreens.create_window (1270, 210, anchor = tk.N + tk.W, window = self.lblDigit21)
		self.lblDigit22 = tk.Label (self, image = self.imgDigit22)
		self.canvasScreens.create_window (1330, 210, anchor = tk.N + tk.W, window = self.lblDigit22)
		self.lblDigit23 = tk.Label (self, image = self.imgDigit23)
		self.canvasScreens.create_window (1390, 210, anchor = tk.N + tk.W, window = self.lblDigit23)

		# Labels for the lights and digits
		self.lblRow1 = tk.Label (self, font = config.fontlabels, text = "A  B  C  D", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 88, anchor = tk.N + tk.W, window = self.lblRow1)
		self.lblRow2 = tk.Label (self, font = config.fontlabels, text = "E  F  G  H", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 148, anchor = tk.N + tk.W, window = self.lblRow2)
		self.lblRow3 = tk.Label (self, font = config.fontlabels, text = "I  J  K  L", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 208, anchor = tk.N + tk.W, window = self.lblRow3)
		self.lblRow4 = tk.Label (self, font = config.fontlabels, text = "M  N  O  P", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 268, anchor = tk.N + tk.W, window = self.lblRow4)
		self.lblRow5 = tk.Label (self, font = config.fontlabels, text = "Q  R  S  T", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 328, anchor = tk.N + tk.W, window = self.lblRow5)
		self.lblRow6 = tk.Label (self, font = config.fontlabels, text = "U  V  W  X", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 388, anchor = tk.N + tk.W, window = self.lblRow6)
		self.lblRow7 = tk.Label (self, font = config.fontlabels, text = "Y  5  4  3", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 448, anchor = tk.N + tk.W, window = self.lblRow7)
		self.lblRow8 = tk.Label (self, font = config.fontlabels, text = "Z  2  1  0", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 508, anchor = tk.N + tk.W, window = self.lblRow8)
		self.lblRow9 = tk.Label (self, font = config.fontlabels, text = "6  7  8  9", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (854, 568, anchor = tk.N + tk.W, window = self.lblRow9)
		self.lblRow1Prime = tk.Label (self, font = config.fontlabels, text = "A' B' C' D'", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (1024, 88, anchor = tk.N + tk.W, window = self.lblRow1Prime)
		self.lblRow2Prime = tk.Label (self, font = config.fontlabels, text = "E' F' G' H'", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (1024, 148, anchor = tk.N + tk.W, window = self.lblRow2Prime)
		self.lblRow3Prime = tk.Label (self, font = config.fontlabels, text = "I' J' K' L'", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (1024, 208, anchor = tk.N + tk.W, window = self.lblRow3Prime)
		self.lblRow4Prime = tk.Label (self, font = config.fontlabels, text = "M' N' O' P'", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (1024, 268, anchor = tk.N + tk.W, window = self.lblRow4Prime)
		self.lblRow5Prime = tk.Label (self, font = config.fontlabels, text = "Q' R' S' T'", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (1024, 328, anchor = tk.N + tk.W, window = self.lblRow5Prime)
		self.lblRow6Prime = tk.Label (self, font = config.fontlabels, text = "U' V' W' X'", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (1024, 388, anchor = tk.N + tk.W, window = self.lblRow6Prime)
		self.lblRow8Dup = tk.Label (self, font = config.fontlabels, text = "Z  2  1  0", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (1024, 508, anchor = tk.N + tk.W, window = self.lblRow8Dup)
		self.lblPassword = tk.Label (self, font = config.fontlabels, text = "Your password is:", bg = config.framebgcolor, fg = config.windowfgcolor)
		self.canvasScreens.create_window (1214, 58, anchor = tk.N + tk.W, window = self.lblPassword)

	# One of these code blocks fires when one of the buttons in the Command List or one of the icons from the Stage Select screen is clicked.
	def dotoggleBitA (self):
		if (self.varBitA.get()):
			self.varBitA.set (False)
			self.imgBitA.config (file = config.assets ["light-off"])
			self.imgDrLightStormEagle.config (file = config.assets ["dr-light"])
		else:
			self.varBitA.set (True)
			self.imgBitA.config (file = config.assets ["light-on-indigo"])
			self.imgDrLightStormEagle.config (file = config.assets ["dr-light-no"])
		self.getpassword()
	def dotoggleBitB (self):
		if (self.varBitB.get()):
			self.varBitB.set (False)
			self.imgBitB.config (file = config.assets ["light-off"])
			self.imgDrLightFlameMammoth.config (file = config.assets ["dr-light"])
		else:
			self.varBitB.set (True)
			self.imgBitB.config (file = config.assets ["light-on-indigo"])
			self.imgDrLightFlameMammoth.config (file = config.assets ["dr-light-no"])
		self.getpassword()
	def dotoggleBitC (self):
		if (self.varBitC.get()):
			self.varBitC.set (False)
			self.imgBitC.config (file = config.assets ["light-off"])
			self.imgDrLightStingChameleon.config (file = config.assets ["dr-light"])
		else:
			self.varBitC.set (True)
			self.imgBitC.config (file = config.assets ["light-on-indigo"])
			self.imgDrLightStingChameleon.config (file = config.assets ["dr-light-no"])
		self.getpassword()
	def dotoggleBitD (self):
		if (self.varBitD.get()):
			self.varBitD.set (False)
			self.imgBitD.config (file = config.assets ["light-off"])
			self.imgDrLightChillPenguin.config (file = config.assets ["dr-light"])
		else:
			self.varBitD.set (True)
			self.imgBitD.config (file = config.assets ["light-on-indigo"])
			self.imgDrLightChillPenguin.config (file = config.assets ["dr-light-no"])
		self.getpassword()
	def dotoggleBitE (self):
		if (self.varBitE.get()):
			self.varBitE.set (False)
			self.imgBitE.config (file = config.assets ["light-off"])
			self.imgSubTankStormEagle.config (file = config.assets ["sub-tank"])
		else:
			self.varBitE.set (True)
			self.imgBitE.config (file = config.assets ["light-on-orange"])
			self.imgSubTankStormEagle.config (file = config.assets ["sub-tank-no"])
		self.getpassword()
	def dotoggleBitF (self):
		if (self.varBitF.get()):
			self.varBitF.set (False)
			self.imgBitF.config (file = config.assets ["light-off"])
			self.imgSubTankArmoredArmadillo.config (file = config.assets ["sub-tank"])
		else:
			self.varBitF.set (True)
			self.imgBitF.config (file = config.assets ["light-on-orange"])
			self.imgSubTankArmoredArmadillo.config (file = config.assets ["sub-tank-no"])
		self.getpassword()
	def dotoggleBitG (self):
		if (self.varBitG.get()):
			self.varBitG.set (False)
			self.imgBitG.config (file = config.assets ["light-off"])
			self.imgSubTankSparkMandrill.config (file = config.assets ["sub-tank"])
		else:
			self.varBitG.set (True)
			self.imgBitG.config (file = config.assets ["light-on-orange"])
			self.imgSubTankSparkMandrill.config (file = config.assets ["sub-tank-no"])
		self.getpassword()
	def dotoggleBitH (self):
		if (self.varBitH.get()):
			self.varBitH.set (False)
			self.imgBitH.config (file = config.assets ["light-off"])
			self.imgSubTankFlameMammoth.config (file = config.assets ["sub-tank"])
		else:
			self.varBitH.set (True)
			self.imgBitH.config (file = config.assets ["light-on-orange"])
			self.imgSubTankFlameMammoth.config (file = config.assets ["sub-tank-no"])
		self.getpassword()
	def dotoggleBitI (self):
		if (self.varBitI.get()):
			self.varBitI.set (False)
			self.imgBitI.config (file = config.assets ["light-off"])
			self.imgHeartTankChillPenguin.config (file = config.assets ["heart-tank"])
		else:
			self.varBitI.set (True)
			self.imgBitI.config (file = config.assets ["light-on-red"])
			self.imgHeartTankChillPenguin.config (file = config.assets ["heart-tank-no"])
		self.getpassword()
	def dotoggleBitJ (self):
		if (self.varBitJ.get()):
			self.varBitJ.set (False)
			self.imgBitJ.config (file = config.assets ["light-off"])
			self.imgHeartTankArmoredArmadillo.config (file = config.assets ["heart-tank"])
		else:
			self.varBitJ.set (True)
			self.imgBitJ.config (file = config.assets ["light-on-red"])
			self.imgHeartTankArmoredArmadillo.config (file = config.assets ["heart-tank-no"])
		self.getpassword()
	def dotoggleBitK (self):
		if (self.varBitK.get()):
			self.varBitK.set (False)
			self.imgBitK.config (file = config.assets ["light-off"])
			self.imgHeartTankStormEagle.config (file = config.assets ["heart-tank"])
		else:
			self.varBitK.set (True)
			self.imgBitK.config (file = config.assets ["light-on-red"])
			self.imgHeartTankStormEagle.config (file = config.assets ["heart-tank-no"])
		self.getpassword()
	def dotoggleBitL (self):
		if (self.varBitL.get()):
			self.varBitL.set (False)
			self.imgBitL.config (file = config.assets ["light-off"])
			self.imgHeartTankStingChameleon.config (file = config.assets ["heart-tank"])
		else:
			self.varBitL.set (True)
			self.imgBitL.config (file = config.assets ["light-on-red"])
			self.imgHeartTankStingChameleon.config (file = config.assets ["heart-tank-no"])
		self.getpassword()
	def dotoggleBitM (self):
		if (self.varBitM.get()):
			self.varBitM.set (False)
			self.imgBitM.config (file = config.assets ["light-off"])
			self.imgHeartTankFlameMammoth.config (file = config.assets ["heart-tank"])
		else:
			self.varBitM.set (True)
			self.imgBitM.config (file = config.assets ["light-on-red"])
			self.imgHeartTankFlameMammoth.config (file = config.assets ["heart-tank-no"])
		self.getpassword()
	def dotoggleBitN (self):
		if (self.varBitN.get()):
			self.varBitN.set (False)
			self.imgBitN.config (file = config.assets ["light-off"])
			self.imgHeartTankBoomerKuwanger.config (file = config.assets ["heart-tank"])
		else:
			self.varBitN.set (True)
			self.imgBitN.config (file = config.assets ["light-on-red"])
			self.imgHeartTankBoomerKuwanger.config (file = config.assets ["heart-tank-no"])
		self.getpassword()
	def dotoggleBitO (self):
		if (self.varBitO.get()):
			self.varBitO.set (False)
			self.imgBitO.config (file = config.assets ["light-off"])
			self.imgHeartTankSparkMandrill.config (file = config.assets ["heart-tank"])
		else:
			self.varBitO.set (True)
			self.imgBitO.config (file = config.assets ["light-on-red"])
			self.imgHeartTankSparkMandrill.config (file = config.assets ["heart-tank-no"])
		self.getpassword()
	def dotoggleBitP (self):
		if (self.varBitP.get()):
			self.varBitP.set (False)
			self.imgBitP.config (file = config.assets ["light-off"])
			self.imgHeartTankLaunchOctopus.config (file = config.assets ["heart-tank"])
		else:
			self.varBitP.set (True)
			self.imgBitP.config (file = config.assets ["light-on-red"])
			self.imgHeartTankLaunchOctopus.config (file = config.assets ["heart-tank-no"])
		self.getpassword()
	def dotoggleBitQ (self):
		if (self.varBitQ.get()):
			self.varBitQ.set (False)
			self.imgBitQ.config (file = config.assets ["light-off"])
			self.imgWeaponHomingTorpedo.config (file = config.assets ["weapon-homing-t"])
		else:
			self.varBitQ.set (True)
			self.imgBitQ.config (file = config.assets ["light-on-purple"])
			self.imgWeaponHomingTorpedo.config (file = config.assets ["weapon-homing-t-no"])
		self.getpassword()
	def dotoggleBitR (self):
		if (self.varBitR.get()):
			self.varBitR.set (False)
			self.imgBitR.config (file = config.assets ["light-off"])
			self.imgWeaponChameleonSting.config (file = config.assets ["weapon-c-sting"])
		else:
			self.varBitR.set (True)
			self.imgBitR.config (file = config.assets ["light-on-purple"])
			self.imgWeaponChameleonSting.config (file = config.assets ["weapon-c-sting-no"])
		self.getpassword()
	def dotoggleBitS (self):
		if (self.varBitS.get()):
			self.varBitS.set (False)
			self.imgBitS.config (file = config.assets ["light-off"])
			self.imgWeaponRollingShield.config (file = config.assets ["weapon-r-shield"])
		else:
			self.varBitS.set (True)
			self.imgBitS.config (file = config.assets ["light-on-purple"])
			self.imgWeaponRollingShield.config (file = config.assets ["weapon-r-shield-no"])
		self.getpassword()
	def dotoggleBitT (self):
		if (self.varBitT.get()):
			self.varBitT.set (False)
			self.imgBitT.config (file = config.assets ["light-off"])
			self.imgWeaponFireWave.config (file = config.assets ["weapon-fire-w"])
		else:
			self.varBitT.set (True)
			self.imgBitT.config (file = config.assets ["light-on-purple"])
			self.imgWeaponFireWave.config (file = config.assets ["weapon-fire-w-no"])
		self.getpassword()
	def dotoggleBitU (self):
		if (self.varBitU.get()):
			self.varBitU.set (False)
			self.imgBitU.config (file = config.assets ["light-off"])
			self.imgWeaponStormTornado.config (file = config.assets ["weapon-storm-t"])
		else:
			self.varBitU.set (True)
			self.imgBitU.config (file = config.assets ["light-on-purple"])
			self.imgWeaponStormTornado.config (file = config.assets ["weapon-storm-t-no"])
		self.getpassword()
	def dotoggleBitV (self):
		if (self.varBitV.get()):
			self.varBitV.set (False)
			self.imgBitV.config (file = config.assets ["light-off"])
			self.imgWeaponElectricSpark.config (file = config.assets ["weapon-e-spark"])
		else:
			self.varBitV.set (True)
			self.imgBitV.config (file = config.assets ["light-on-purple"])
			self.imgWeaponElectricSpark.config (file = config.assets ["weapon-e-spark-no"])
		self.getpassword()
	def dotoggleBitW (self):
		if (self.varBitW.get()):
			self.varBitW.set (False)
			self.imgBitW.config (file = config.assets ["light-off"])
			self.imgWeaponBoomerangCutter.config (file = config.assets ["weapon-b-cutter"])
		else:
			self.varBitW.set (True)
			self.imgBitW.config (file = config.assets ["light-on-purple"])
			self.imgWeaponBoomerangCutter.config (file = config.assets ["weapon-b-cutter-no"])
		self.getpassword()
	def dotoggleBitX (self):
		if (self.varBitX.get()):
			self.varBitX.set (False)
			self.imgBitX.config (file = config.assets ["light-off"])
			self.imgWeaponShotgunIce.config (file = config.assets ["weapon-s-ice"])
		else:
			self.varBitX.set (True)
			self.imgBitX.config (file = config.assets ["light-on-purple"])
			self.imgWeaponShotgunIce.config (file = config.assets ["weapon-s-ice-no"])
		self.getpassword()
	def dotoggleBitY (self):
		if (self.varBitY.get()):
			self.varBitY.set (False)
			self.imgBitY.config (file = config.assets ["light-off"])
			self.imgDrLightArmoredArmadillo.config (file = config.assets ["dr-light"])
		else:
			self.varBitY.set (True)
			self.imgBitY.config (file = config.assets ["light-on-indigo"])
			self.imgDrLightArmoredArmadillo.config (file = config.assets ["dr-light-no"])
		self.getpassword()

	def dotoggleBitZ (self):
		if (self.varBitZ.get()):
			if tk.messagebox.askyesno ("Advisory", "Starting from the beginning requires you to have an empty inventory.\n\nThat means all the data bits will have to be reset.\n\nIs that okay?"):  # Pop up a warning message with yes/no buttons.
				self.varBitA.set (False)
				self.imgBitA.config (file = config.assets ["light-off"])
				self.imgDrLightStormEagle.config (file = config.assets ["dr-light"])
				self.btnDrLightStormEagle.config (state = tk.DISABLED)
				self.chkBitA.config (state = tk.DISABLED)
				self.btnBitA.config (state = tk.DISABLED)
				self.varBitB.set (False)
				self.imgBitB.config (file = config.assets ["light-off"])
				self.imgDrLightFlameMammoth.config (file = config.assets ["dr-light"])
				self.btnDrLightFlameMammoth.config (state = tk.DISABLED)
				self.chkBitB.config (state = tk.DISABLED)
				self.btnBitB.config (state = tk.DISABLED)
				self.varBitC.set (False)
				self.imgBitC.config (file = config.assets ["light-off"])
				self.imgDrLightStingChameleon.config (file = config.assets ["dr-light"])
				self.btnDrLightStingChameleon.config (state = tk.DISABLED)
				self.chkBitC.config (state = tk.DISABLED)
				self.btnBitC.config (state = tk.DISABLED)
				self.varBitD.set (False)
				self.imgBitD.config (file = config.assets ["light-off"])
				self.imgDrLightChillPenguin.config (file = config.assets ["dr-light"])
				self.btnDrLightChillPenguin.config (state = tk.DISABLED)
				self.chkBitD.config (state = tk.DISABLED)
				self.btnBitD.config (state = tk.DISABLED)
				self.varBitE.set (False)
				self.imgBitE.config (file = config.assets ["light-off"])
				self.imgSubTankStormEagle.config (file = config.assets ["sub-tank"])
				self.btnSubTankStormEagle.config (state = tk.DISABLED)
				self.chkBitE.config (state = tk.DISABLED)
				self.btnBitE.config (state = tk.DISABLED)
				self.varBitF.set (False)
				self.imgBitF.config (file = config.assets ["light-off"])
				self.imgSubTankArmoredArmadillo.config (file = config.assets ["sub-tank"])
				self.btnSubTankArmoredArmadillo.config (state = tk.DISABLED)
				self.chkBitF.config (state = tk.DISABLED)
				self.btnBitF.config (state = tk.DISABLED)
				self.varBitG.set (False)
				self.imgBitG.config (file = config.assets ["light-off"])
				self.imgSubTankSparkMandrill.config (file = config.assets ["sub-tank"])
				self.btnSubTankSparkMandrill.config (state = tk.DISABLED)
				self.chkBitG.config (state = tk.DISABLED)
				self.btnBitG.config (state = tk.DISABLED)
				self.varBitH.set (False)
				self.imgBitH.config (file = config.assets ["light-off"])
				self.imgSubTankFlameMammoth.config (file = config.assets ["sub-tank"])
				self.btnSubTankFlameMammoth.config (state = tk.DISABLED)
				self.chkBitH.config (state = tk.DISABLED)
				self.btnBitH.config (state = tk.DISABLED)
				self.varBitI.set (False)
				self.imgBitI.config (file = config.assets ["light-off"])
				self.imgHeartTankChillPenguin.config (file = config.assets ["heart-tank"])
				self.btnHeartTankChillPenguin.config (state = tk.DISABLED)
				self.chkBitI.config (state = tk.DISABLED)
				self.btnBitI.config (state = tk.DISABLED)
				self.varBitJ.set (False)
				self.imgBitJ.config (file = config.assets ["light-off"])
				self.imgHeartTankArmoredArmadillo.config (file = config.assets ["heart-tank"])
				self.btnHeartTankArmoredArmadillo.config (state = tk.DISABLED)
				self.chkBitJ.config (state = tk.DISABLED)
				self.btnBitJ.config (state = tk.DISABLED)
				self.varBitK.set (False)
				self.imgBitK.config (file = config.assets ["light-off"])
				self.imgHeartTankStormEagle.config (file = config.assets ["heart-tank"])
				self.btnHeartTankStormEagle.config (state = tk.DISABLED)
				self.chkBitK.config (state = tk.DISABLED)
				self.btnBitK.config (state = tk.DISABLED)
				self.varBitL.set (False)
				self.imgBitL.config (file = config.assets ["light-off"])
				self.imgHeartTankStingChameleon.config (file = config.assets ["heart-tank"])
				self.btnHeartTankStingChameleon.config (state = tk.DISABLED)
				self.chkBitL.config (state = tk.DISABLED)
				self.btnBitL.config (state = tk.DISABLED)
				self.varBitM.set (False)
				self.imgBitM.config (file = config.assets ["light-off"])
				self.imgHeartTankFlameMammoth.config (file = config.assets ["heart-tank"])
				self.btnHeartTankFlameMammoth.config (state = tk.DISABLED)
				self.chkBitM.config (state = tk.DISABLED)
				self.btnBitM.config (state = tk.DISABLED)
				self.varBitN.set (False)
				self.imgBitN.config (file = config.assets ["light-off"])
				self.imgHeartTankBoomerKuwanger.config (file = config.assets ["heart-tank"])
				self.btnHeartTankBoomerKuwanger.config (state = tk.DISABLED)
				self.chkBitN.config (state = tk.DISABLED)
				self.btnBitN.config (state = tk.DISABLED)
				self.varBitO.set (False)
				self.imgBitO.config (file = config.assets ["light-off"])
				self.imgHeartTankSparkMandrill.config (file = config.assets ["heart-tank"])
				self.btnHeartTankSparkMandrill.config (state = tk.DISABLED)
				self.chkBitO.config (state = tk.DISABLED)
				self.btnBitO.config (state = tk.DISABLED)
				self.varBitP.set (False)
				self.imgBitP.config (file = config.assets ["light-off"])
				self.imgHeartTankLaunchOctopus.config (file = config.assets ["heart-tank"])
				self.btnHeartTankLaunchOctopus.config (state = tk.DISABLED)
				self.chkBitP.config (state = tk.DISABLED)
				self.btnBitP.config (state = tk.DISABLED)
				self.varBitQ.set (False)
				self.imgBitQ.config (file = config.assets ["light-off"])
				self.imgWeaponHomingTorpedo.config (file = config.assets ["weapon-homing-t"])
				self.btnWeaponHomingTorpedo.config (state = tk.DISABLED)
				self.chkBitQ.config (state = tk.DISABLED)
				self.btnBitQ.config (state = tk.DISABLED)
				self.varBitR.set (False)
				self.imgBitR.config (file = config.assets ["light-off"])
				self.imgWeaponChameleonSting.config (file = config.assets ["weapon-c-sting"])
				self.btnWeaponChameleonSting.config (state = tk.DISABLED)
				self.chkBitR.config (state = tk.DISABLED)
				self.btnBitR.config (state = tk.DISABLED)
				self.varBitS.set (False)
				self.imgBitS.config (file = config.assets ["light-off"])
				self.imgWeaponRollingShield.config (file = config.assets ["weapon-r-shield"])
				self.btnWeaponRollingShield.config (state = tk.DISABLED)
				self.chkBitS.config (state = tk.DISABLED)
				self.btnBitS.config (state = tk.DISABLED)
				self.varBitT.set (False)
				self.imgBitT.config (file = config.assets ["light-off"])
				self.imgWeaponFireWave.config (file = config.assets ["weapon-fire-w"])
				self.btnWeaponFireWave.config (state = tk.DISABLED)
				self.chkBitT.config (state = tk.DISABLED)
				self.btnBitT.config (state = tk.DISABLED)
				self.varBitU.set (False)
				self.imgBitU.config (file = config.assets ["light-off"])
				self.imgWeaponStormTornado.config (file = config.assets ["weapon-storm-t"])
				self.btnWeaponStormTornado.config (state = tk.DISABLED)
				self.chkBitU.config (state = tk.DISABLED)
				self.btnBitU.config (state = tk.DISABLED)
				self.varBitV.set (False)
				self.imgBitV.config (file = config.assets ["light-off"])
				self.imgWeaponElectricSpark.config (file = config.assets ["weapon-e-spark"])
				self.btnWeaponElectricSpark.config (state = tk.DISABLED)
				self.chkBitV.config (state = tk.DISABLED)
				self.btnBitV.config (state = tk.DISABLED)
				self.varBitW.set (False)
				self.imgBitW.config (file = config.assets ["light-off"])
				self.imgWeaponBoomerangCutter.config (file = config.assets ["weapon-b-cutter"])
				self.btnWeaponBoomerangCutter.config (state = tk.DISABLED)
				self.chkBitW.config (state = tk.DISABLED)
				self.btnBitW.config (state = tk.DISABLED)
				self.varBitX.set (False)
				self.imgBitX.config (file = config.assets ["light-off"])
				self.imgWeaponShotgunIce.config (file = config.assets ["weapon-s-ice"])
				self.btnWeaponShotgunIce.config (state = tk.DISABLED)
				self.chkBitX.config (state = tk.DISABLED)
				self.btnBitX.config (state = tk.DISABLED)
				self.varBitY.set (False)
				self.imgBitY.config (file = config.assets ["light-off"])
				self.imgDrLightArmoredArmadillo.config (file = config.assets ["dr-light"])
				self.btnDrLightArmoredArmadillo.config (state = tk.DISABLED)
				self.chkBitY.config (state = tk.DISABLED)
				self.btnBitY.config (state = tk.DISABLED)
				self.varBitZ.set (False)
				self.imgBitZ.config (file = config.assets ["light-off"])
		else:
			self.btnDrLightStormEagle.config (state = tk.NORMAL)
			self.btnBitA.config (state = tk.NORMAL)
			self.chkBitA.config (state = tk.NORMAL)
			self.btnDrLightFlameMammoth.config (state = tk.NORMAL)
			self.btnBitB.config (state = tk.NORMAL)
			self.chkBitB.config (state = tk.NORMAL)
			self.btnDrLightStingChameleon.config (state = tk.NORMAL)
			self.btnBitC.config (state = tk.NORMAL)
			self.chkBitC.config (state = tk.NORMAL)
			self.btnDrLightChillPenguin.config (state = tk.NORMAL)
			self.btnBitD.config (state = tk.NORMAL)
			self.chkBitD.config (state = tk.NORMAL)
			self.btnSubTankStormEagle.config (state = tk.NORMAL)
			self.btnBitE.config (state = tk.NORMAL)
			self.chkBitE.config (state = tk.NORMAL)
			self.btnSubTankArmoredArmadillo.config (state = tk.NORMAL)
			self.btnBitF.config (state = tk.NORMAL)
			self.chkBitF.config (state = tk.NORMAL)
			self.btnSubTankSparkMandrill.config (state = tk.NORMAL)
			self.btnBitG.config (state = tk.NORMAL)
			self.chkBitG.config (state = tk.NORMAL)
			self.btnSubTankFlameMammoth.config (state = tk.NORMAL)
			self.btnBitH.config (state = tk.NORMAL)
			self.chkBitH.config (state = tk.NORMAL)
			self.btnHeartTankChillPenguin.config (state = tk.NORMAL)
			self.btnBitI.config (state = tk.NORMAL)
			self.chkBitI.config (state = tk.NORMAL)
			self.btnHeartTankArmoredArmadillo.config (state = tk.NORMAL)
			self.btnBitJ.config (state = tk.NORMAL)
			self.chkBitJ.config (state = tk.NORMAL)
			self.btnHeartTankStormEagle.config (state = tk.NORMAL)
			self.btnBitK.config (state = tk.NORMAL)
			self.chkBitK.config (state = tk.NORMAL)
			self.btnHeartTankStingChameleon.config (state = tk.NORMAL)
			self.btnBitL.config (state = tk.NORMAL)
			self.chkBitL.config (state = tk.NORMAL)
			self.btnHeartTankFlameMammoth.config (state = tk.NORMAL)
			self.btnBitM.config (state = tk.NORMAL)
			self.chkBitM.config (state = tk.NORMAL)
			self.btnHeartTankBoomerKuwanger.config (state = tk.NORMAL)
			self.btnBitN.config (state = tk.NORMAL)
			self.chkBitN.config (state = tk.NORMAL)
			self.btnHeartTankSparkMandrill.config (state = tk.NORMAL)
			self.btnBitO.config (state = tk.NORMAL)
			self.chkBitO.config (state = tk.NORMAL)
			self.btnHeartTankLaunchOctopus.config (state = tk.NORMAL)
			self.btnBitP.config (state = tk.NORMAL)
			self.chkBitP.config (state = tk.NORMAL)
			self.btnWeaponHomingTorpedo.config (state = tk.NORMAL)
			self.btnBitQ.config (state = tk.NORMAL)
			self.chkBitQ.config (state = tk.NORMAL)
			self.btnWeaponChameleonSting.config (state = tk.NORMAL)
			self.btnBitR.config (state = tk.NORMAL)
			self.chkBitR.config (state = tk.NORMAL)
			self.btnWeaponRollingShield.config (state = tk.NORMAL)
			self.btnBitS.config (state = tk.NORMAL)
			self.chkBitS.config (state = tk.NORMAL)
			self.btnWeaponFireWave.config (state = tk.NORMAL)
			self.btnBitT.config (state = tk.NORMAL)
			self.chkBitT.config (state = tk.NORMAL)
			self.btnWeaponStormTornado.config (state = tk.NORMAL)
			self.btnBitU.config (state = tk.NORMAL)
			self.chkBitU.config (state = tk.NORMAL)
			self.btnWeaponElectricSpark.config (state = tk.NORMAL)
			self.btnBitV.config (state = tk.NORMAL)
			self.chkBitV.config (state = tk.NORMAL)
			self.btnWeaponBoomerangCutter.config (state = tk.NORMAL)
			self.btnBitW.config (state = tk.NORMAL)
			self.chkBitW.config (state = tk.NORMAL)
			self.btnWeaponShotgunIce.config (state = tk.NORMAL)
			self.btnBitX.config (state = tk.NORMAL)
			self.chkBitX.config (state = tk.NORMAL)
			self.btnDrLightArmoredArmadillo.config (state = tk.NORMAL)
			self.btnBitY.config (state = tk.NORMAL)
			self.chkBitY.config (state = tk.NORMAL)
			self.varBitZ.set (True)
			self.imgBitZ.config (file = config.assets ["light-on-lemon"])
		self.getpassword()

	def dotoggleBit2 (self):
		if (self.varBit2.get()):
			self.varBit2.set (False)
			self.imgBit2.config (file = config.assets ["light-off"])
		else:
			self.varBit2.set (True)
			self.imgBit2.config (file = config.assets ["light-on-lemon"])
		self.getpassword()
	def dotoggleBit1 (self):
		if (self.varBit1.get()):
			self.varBit1.set (False)
			self.imgBit1.config (file = config.assets ["light-off"])
		else:
			self.varBit1.set (True)
			self.imgBit1.config (file = config.assets ["light-on-lemon"])
		self.getpassword()
	def dotoggleBit0 (self):
		if (self.varBit0.get()):
			self.varBit0.set (False)
			self.imgBit0.config (file = config.assets ["light-off"])
		else:
			self.varBit0.set (True)
			self.imgBit0.config (file = config.assets ["light-on-lemon"])
		self.getpassword()

	# This code is called by dotoggleBit*.
	def getpassword (self):
		self.varBit3.set (self.varBitA.get() ^ self.varBitB.get() ^ self.varBitC.get() ^ self.varBitD.get() ^ self.varBitE.get() ^ self.varBitF.get() ^ self.varBitG.get() ^ self.varBitH.get())
		self.varBit4.set (self.varBitI.get() ^ self.varBitJ.get() ^ self.varBitK.get() ^ self.varBitL.get() ^ self.varBitM.get() ^ self.varBitN.get() ^ self.varBitO.get() ^ self.varBitP.get())
		self.varBit5.set (self.varBitQ.get() ^ self.varBitR.get() ^ self.varBitS.get() ^ self.varBitT.get() ^ self.varBitU.get() ^ self.varBitV.get() ^ self.varBitW.get() ^ self.varBitX.get())
		self.varBit6.set (self.varBitA.get() ^ self.varBitE.get() ^ self.varBitI.get() ^ self.varBitM.get() ^ self.varBitQ.get() ^ self.varBitU.get() ^ self.varBitY.get() ^ self.varBitZ.get())
		self.varBit7.set (self.varBitB.get() ^ self.varBitF.get() ^ self.varBitJ.get() ^ self.varBitN.get() ^ self.varBitR.get() ^ self.varBitV.get() ^ self.varBit5.get() ^ self.varBit2.get())
		self.varBit8.set (self.varBitC.get() ^ self.varBitG.get() ^ self.varBitK.get() ^ self.varBitO.get() ^ self.varBitS.get() ^ self.varBitW.get() ^ self.varBit4.get() ^ self.varBit1.get())
		self.varBit9.set (self.varBitD.get() ^ self.varBitH.get() ^ self.varBitL.get() ^ self.varBitP.get() ^ self.varBitT.get() ^ self.varBitX.get() ^ self.varBit3.get() ^ self.varBit0.get())
		self.varBitAPrime.set (self.varBitA.get() ^ self.varBitZ.get())
		self.varBitBPrime.set (self.varBitB.get() ^ self.varBit2.get())
		self.varBitCPrime.set (self.varBitC.get() ^ self.varBit1.get())
		self.varBitDPrime.set (self.varBitD.get() ^ self.varBit0.get())
		self.varBitEPrime.set (self.varBitE.get() ^ self.varBitZ.get())
		self.varBitFPrime.set (self.varBitF.get() ^ self.varBit2.get())
		self.varBitGPrime.set (self.varBitG.get() ^ self.varBit1.get())
		self.varBitHPrime.set (self.varBitH.get() ^ self.varBit0.get())
		self.varBitIPrime.set (self.varBitI.get() ^ self.varBitZ.get())
		self.varBitJPrime.set (self.varBitJ.get() ^ self.varBit2.get())
		self.varBitKPrime.set (self.varBitK.get() ^ self.varBit1.get())
		self.varBitLPrime.set (self.varBitL.get() ^ self.varBit0.get())
		self.varBitMPrime.set (self.varBitM.get() ^ self.varBitZ.get())
		self.varBitNPrime.set (self.varBitN.get() ^ self.varBit2.get())
		self.varBitOPrime.set (self.varBitO.get() ^ self.varBit1.get())
		self.varBitPPrime.set (self.varBitP.get() ^ self.varBit0.get())
		self.varBitQPrime.set (self.varBitQ.get() ^ self.varBitZ.get())
		self.varBitRPrime.set (self.varBitR.get() ^ self.varBit2.get())
		self.varBitSPrime.set (self.varBitS.get() ^ self.varBit1.get())
		self.varBitTPrime.set (self.varBitT.get() ^ self.varBit0.get())
		self.varBitUPrime.set (self.varBitU.get() ^ self.varBitZ.get())
		self.varBitVPrime.set (self.varBitV.get() ^ self.varBit2.get())
		self.varBitWPrime.set (self.varBitW.get() ^ self.varBit1.get())
		self.varBitXPrime.set (self.varBitX.get() ^ self.varBit0.get())

		self.imgBit3.config (file = config.assets ["light-on-lime"] if self.varBit3.get() else config.assets ["light-off"])
		self.imgBit4.config (file = config.assets ["light-on-lime"] if self.varBit4.get() else config.assets ["light-off"])
		self.imgBit5.config (file = config.assets ["light-on-lime"] if self.varBit5.get() else config.assets ["light-off"])
		self.imgBit6.config (file = config.assets ["light-on-lime"] if self.varBit6.get() else config.assets ["light-off"])
		self.imgBit7.config (file = config.assets ["light-on-lime"] if self.varBit7.get() else config.assets ["light-off"])
		self.imgBit8.config (file = config.assets ["light-on-lime"] if self.varBit8.get() else config.assets ["light-off"])
		self.imgBit9.config (file = config.assets ["light-on-lime"] if self.varBit9.get() else config.assets ["light-off"])
		self.imgBitAPrime.config (file = config.assets ["light-on-indigo"] if self.varBitAPrime.get() else config.assets ["light-off"])
		self.imgBitBPrime.config (file = config.assets ["light-on-indigo"] if self.varBitBPrime.get() else config.assets ["light-off"])
		self.imgBitCPrime.config (file = config.assets ["light-on-indigo"] if self.varBitCPrime.get() else config.assets ["light-off"])
		self.imgBitDPrime.config (file = config.assets ["light-on-indigo"] if self.varBitDPrime.get() else config.assets ["light-off"])
		self.imgBitEPrime.config (file = config.assets ["light-on-orange"] if self.varBitEPrime.get() else config.assets ["light-off"])
		self.imgBitFPrime.config (file = config.assets ["light-on-orange"] if self.varBitFPrime.get() else config.assets ["light-off"])
		self.imgBitGPrime.config (file = config.assets ["light-on-orange"] if self.varBitGPrime.get() else config.assets ["light-off"])
		self.imgBitHPrime.config (file = config.assets ["light-on-orange"] if self.varBitHPrime.get() else config.assets ["light-off"])
		self.imgBitIPrime.config (file = config.assets ["light-on-red"] if self.varBitIPrime.get() else config.assets ["light-off"])
		self.imgBitJPrime.config (file = config.assets ["light-on-red"] if self.varBitJPrime.get() else config.assets ["light-off"])
		self.imgBitKPrime.config (file = config.assets ["light-on-red"] if self.varBitKPrime.get() else config.assets ["light-off"])
		self.imgBitLPrime.config (file = config.assets ["light-on-red"] if self.varBitLPrime.get() else config.assets ["light-off"])
		self.imgBitMPrime.config (file = config.assets ["light-on-red"] if self.varBitMPrime.get() else config.assets ["light-off"])
		self.imgBitNPrime.config (file = config.assets ["light-on-red"] if self.varBitNPrime.get() else config.assets ["light-off"])
		self.imgBitOPrime.config (file = config.assets ["light-on-red"] if self.varBitOPrime.get() else config.assets ["light-off"])
		self.imgBitPPrime.config (file = config.assets ["light-on-red"] if self.varBitPPrime.get() else config.assets ["light-off"])
		self.imgBitQPrime.config (file = config.assets ["light-on-purple"] if self.varBitQPrime.get() else config.assets ["light-off"])
		self.imgBitRPrime.config (file = config.assets ["light-on-purple"] if self.varBitRPrime.get() else config.assets ["light-off"])
		self.imgBitSPrime.config (file = config.assets ["light-on-purple"] if self.varBitSPrime.get() else config.assets ["light-off"])
		self.imgBitTPrime.config (file = config.assets ["light-on-purple"] if self.varBitTPrime.get() else config.assets ["light-off"])
		self.imgBitUPrime.config (file = config.assets ["light-on-purple"] if self.varBitUPrime.get() else config.assets ["light-off"])
		self.imgBitVPrime.config (file = config.assets ["light-on-purple"] if self.varBitVPrime.get() else config.assets ["light-off"])
		self.imgBitWPrime.config (file = config.assets ["light-on-purple"] if self.varBitWPrime.get() else config.assets ["light-off"])
		self.imgBitXPrime.config (file = config.assets ["light-on-purple"] if self.varBitXPrime.get() else config.assets ["light-off"])

		if (self.varBitFPrime.get()):
			if (self.varBitIPrime.get()):
				self.imgDigit00.config (file = config.assets ["number-5"] if self.varBit9.get() else config.assets ["number-6"])
			else:
				self.imgDigit00.config (file = config.assets ["number-3"] if self.varBit9.get() else config.assets ["number-8"])
		elif (self.varBitIPrime.get()):
			self.imgDigit00.config (file = config.assets ["number-4"] if self.varBit9.get() else config.assets ["number-1"])
		else:
			self.imgDigit00.config (file = config.assets ["number-2"] if self.varBit9.get() else config.assets ["number-7"])

		if (self.varBitAPrime.get()):
			if (self.varBitTPrime.get()):
				self.imgDigit01.config (file = config.assets ["number-2"] if self.varBit4.get() else config.assets ["number-3"])
			else:
				self.imgDigit01.config (file = config.assets ["number-8"] if self.varBit4.get() else config.assets ["number-7"])
		elif (self.varBitTPrime.get()):
			self.imgDigit01.config (file = config.assets ["number-1"] if self.varBit4.get() else config.assets ["number-4"])
		else:
			self.imgDigit01.config (file = config.assets ["number-5"] if self.varBit4.get() else config.assets ["number-6"])

		if (self.varBitHPrime.get()):
			if (self.varBitMPrime.get()):
				self.imgDigit02.config (file = config.assets ["number-8"] if self.varBit2.get() else config.assets ["number-2"])
			else:
				self.imgDigit02.config (file = config.assets ["number-3"] if self.varBit2.get() else config.assets ["number-4"])
		elif (self.varBitMPrime.get()):
			self.imgDigit02.config (file = config.assets ["number-1"] if self.varBit2.get() else config.assets ["number-6"])
		else:
			self.imgDigit02.config (file = config.assets ["number-5"] if self.varBit2.get() else config.assets ["number-7"])

		if (self.varBitKPrime.get()):
			if (self.varBitUPrime.get()):
				self.imgDigit03.config (file = config.assets ["number-2"] if self.varBit0.get() else config.assets ["number-4"])
			else:
				self.imgDigit03.config (file = config.assets ["number-6"] if self.varBit0.get() else config.assets ["number-7"])
		elif (self.varBitUPrime.get()):
			self.imgDigit03.config (file = config.assets ["number-5"] if self.varBit0.get() else config.assets ["number-8"])
		else:
			self.imgDigit03.config (file = config.assets ["number-3"] if self.varBit0.get() else config.assets ["number-1"])

		if (self.varBitCPrime.get()):
			if (self.varBitQPrime.get()):
				self.imgDigit10.config (file = config.assets ["number-8"] if self.varBit7.get() else config.assets ["number-1"])
			else:
				self.imgDigit10.config (file = config.assets ["number-6"] if self.varBit7.get() else config.assets ["number-4"])
		elif (self.varBitQPrime.get()):
			self.imgDigit10.config (file = config.assets ["number-7"] if self.varBit7.get() else config.assets ["number-5"])
		else:
			self.imgDigit10.config (file = config.assets ["number-3"] if self.varBit7.get() else config.assets ["number-2"])

		if (self.varBitNPrime.get()):
			if (self.varBitWPrime.get()):
				self.imgDigit11.config (file = config.assets ["number-5"] if self.varBit3.get() else config.assets ["number-6"])
			else:
				self.imgDigit11.config (file = config.assets ["number-3"] if self.varBit3.get() else config.assets ["number-1"])
		elif (self.varBitWPrime.get()):
			self.imgDigit11.config (file = config.assets ["number-7"] if self.varBit3.get() else config.assets ["number-4"])
		else:
			self.imgDigit11.config (file = config.assets ["number-2"] if self.varBit3.get() else config.assets ["number-8"])

		if (self.varBitBPrime.get()):
			if (self.varBitSPrime.get()):
				self.imgDigit12.config (file = config.assets ["number-6"] if self.varBit6.get() else config.assets ["number-2"])
			else:
				self.imgDigit12.config (file = config.assets ["number-3"] if self.varBit6.get() else config.assets ["number-7"])
		elif (self.varBitSPrime.get()):
			self.imgDigit12.config (file = config.assets ["number-8"] if self.varBit6.get() else config.assets ["number-1"])
		else:
			self.imgDigit12.config (file = config.assets ["number-5"] if self.varBit6.get() else config.assets ["number-4"])

		if (self.varBitLPrime.get()):
			if (self.varBitVPrime.get()):
				self.imgDigit13.config (file = config.assets ["number-6"] if self.varBitZ.get() else config.assets ["number-3"])
			else:
				self.imgDigit13.config (file = config.assets ["number-2"] if self.varBitZ.get() else config.assets ["number-1"])
		elif (self.varBitVPrime.get()):
			self.imgDigit13.config (file = config.assets ["number-7"] if self.varBitZ.get() else config.assets ["number-5"])
		else:
			self.imgDigit13.config (file = config.assets ["number-8"] if self.varBitZ.get() else config.assets ["number-4"])

		if (self.varBitDPrime.get()):
			if (self.varBitJPrime.get()):
				self.imgDigit20.config (file = config.assets ["number-4"] if self.varBit8.get() else config.assets ["number-6"])
			else:
				self.imgDigit20.config (file = config.assets ["number-8"] if self.varBit8.get() else config.assets ["number-1"])
		elif (self.varBitJPrime.get()):
			self.imgDigit20.config (file = config.assets ["number-2"] if self.varBit8.get() else config.assets ["number-5"])
		else:
			self.imgDigit20.config (file = config.assets ["number-7"] if self.varBit8.get() else config.assets ["number-3"])

		if (self.varBitEPrime.get()):
			if (self.varBitRPrime.get()):
				self.imgDigit21.config (file = config.assets ["number-6"] if self.varBit1.get() else config.assets ["number-3"])
			else:
				self.imgDigit21.config (file = config.assets ["number-7"] if self.varBit1.get() else config.assets ["number-8"])
		elif (self.varBitRPrime.get()):
			self.imgDigit21.config (file = config.assets ["number-4"] if self.varBit1.get() else config.assets ["number-1"])
		else:
			self.imgDigit21.config (file = config.assets ["number-5"] if self.varBit1.get() else config.assets ["number-2"])

		if (self.varBitGPrime.get()):
			if (self.varBitPPrime.get()):
				self.imgDigit22.config (file = config.assets ["number-3"] if self.varBit5.get() else config.assets ["number-5"])
			else:
				self.imgDigit22.config (file = config.assets ["number-1"] if self.varBit5.get() else config.assets ["number-4"])
		elif (self.varBitPPrime.get()):
			self.imgDigit22.config (file = config.assets ["number-6"] if self.varBit5.get() else config.assets ["number-2"])
		else:
			self.imgDigit22.config (file = config.assets ["number-7"] if self.varBit5.get() else config.assets ["number-8"])

		if (self.varBitOPrime.get()):
			if (self.varBitXPrime.get()):
				self.imgDigit23.config (file = config.assets ["number-5"] if self.varBitY.get() else config.assets ["number-6"])
			else:
				self.imgDigit23.config (file = config.assets ["number-2"] if self.varBitY.get() else config.assets ["number-8"])
		elif (self.varBitXPrime.get()):
			self.imgDigit23.config (file = config.assets ["number-3"] if self.varBitY.get() else config.assets ["number-1"])
		else:
			self.imgDigit23.config (file = config.assets ["number-7"] if self.varBitY.get() else config.assets ["number-4"])

	# This code fires when the "Help" button is clicked.
	def dohelp (self):
		tk.messagebox.showinfo ("MMXPG Instructions (1 of 5)", "You can use either the list on the left or the icons displayed on the Stage Select Pane.\n\nSelect:\n * which Dr. Light upgrades you want to have,\n * which Sub Tanks you want to have,\n * which Heart Tanks you want to have,\n * which weapons you want to have (having cleared the respective stages),\n * and which Random Seed Bits you want to toggle.")
		tk.messagebox.showinfo ("MMXPG Instructions (2 of 5)", "As soon as you make a selection, the password is updated immediately.\n\nThe lights on the Password Screen indicate which bits are set, so you can see what's going on behind the scenes.")
		tk.messagebox.showinfo ("MMXPG Instructions (3 of 5)", "If you want to understand the meaning behind the lights, refer to my notes posted on GameFAQs.  There you will see everything in the form of a wiring diagram.")
		tk.messagebox.showinfo ("MMXPG Instructions (4 of 5)", "Above the three Random Seed Bit buttons is a fourth button to indicate whether or not you have cleared the first stage.\n\nIf you click this button, everything will be reset except for the Random Seed Bits.  That's because you can't start from the beginning with any optional upgrades.  The password would fail if you tried.\n\nYou will be given a warning before choosing this.")
		tk.messagebox.showinfo ("MMXPG Instructions (5 of 5)", "In case you're wondering, having Hadouken is contained in the password.  There is additional code to take it away from you after the password is validated.\n\nA simple ROM poke or Game Genie code should bypass this code and re-enable Hadouken from password entry.")

	# This code fires when the "About" button is clicked.
	def doabout (self):
		tk.messagebox.showinfo ("About MMXPG", "MMXPG - Mega Man X Password Generator\n\nWritten by Michael Hayes\n\nDate Of Last Modification:\nJuly 5, 2023")

app = Application()
app.master.title ("Mega Man X Password Generator")
app.master.iconphoto (True, tk.PhotoImage (file = config.workingpath + "icon.png"))
app.master.geometry (config.geometry)
app.configure (bg = config.windowbgcolor)
app.mainloop()

# EOF
